VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Move"
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private m_typeMove As Byte
Private m_pieceMoved As Piece
Private m_pieceCaptured As Piece
Private m_squareFrom As Square
Private m_squareTo As Square

Private m_counterRepeatedPosition As Byte
Private m_turnNo As Integer
Private m_LastMoveTurnNo As Integer
Private m_IsInCheck As Boolean
Private m_IsEnemyInCheck As Boolean
Private m_EnemyStatus As Integer

Private m_counter50MDraw As Byte
Private m_key As String
Private m_notationPgnSan As String
Private m_score As Integer

Private Sub Class_Initialize()
    m_counter50MDraw = 0
    m_counterRepeatedPosition = 0
End Sub

Public Sub BuildMove(ByVal typeMove As Byte, ByVal pieceToMove As Piece, _
            ByVal sqrFrom As Square, ByVal sqrTo As Square, ByVal pieceCapture As Piece)
    m_typeMove = typeMove
    Set m_pieceMoved = pieceToMove
    Set m_squareFrom = sqrFrom
    Set m_squareTo = sqrTo
    Set m_pieceCaptured = pieceCapture
    m_key = m_pieceMoved.Name + m_squareFrom.Name + m_squareTo.Name
    
End Sub

Public Property Get TypeOfMove() As Byte
    TypeOfMove = m_typeMove
End Property

Public Property Get PieceMoved() As Piece
    Set PieceMoved = m_pieceMoved
End Property

Public Sub SetPieceToMove(thisPiece As Piece)
    Set m_pieceMoved = thisPiece
End Sub

Public Property Get pieceCaptured() As Piece
    Set pieceCaptured = m_pieceCaptured
End Property

Public Sub SetPieceCaptured(thisPiece As Piece)
    Set m_pieceCaptured = thisPiece
End Sub

Public Property Get SquareFrom() As Square
    Set SquareFrom = m_squareFrom
End Property

Public Property Get squareTo() As Square
    Set squareTo = m_squareTo
End Property

Public Property Get counterRepeatedPosition() As Byte
    counterRepeatedPosition = m_counterRepeatedPosition
End Property

Public Property Let counterRepeatedPosition(ByVal counterValue As Byte)
    m_counterRepeatedPosition = counterValue
End Property

Public Property Get Score() As Integer
    Score = m_score
End Property

Public Property Let Score(ByVal scoreValue As Integer)
    m_score = scoreValue
End Property

Public Property Get IsThreeMoveRepetition() As Boolean
    IsThreeMoveRepetition = m_counterRepeatedPosition = 2
End Property

Public Property Get MoveNo() As Integer
    MoveNo = m_turnNo \ 2 + 1
End Property

Public Property Get TurnNo() As Integer
    TurnNo = m_turnNo
End Property

Public Property Let TurnNo(ByVal Value As Integer)
    m_turnNo = Value
End Property

Public Property Get LastMoveTurnNo() As Integer
    LastMoveTurnNo = m_LastMoveTurnNo
End Property

Public Property Let LastMoveTurnNo(ByVal Value As Integer)
    m_LastMoveTurnNo = Value
End Property

Public Property Get IsInCheck() As Integer
    IsInCheck = m_IsInCheck
End Property

Public Property Let IsInCheck(ByVal Value As Integer)
    m_IsInCheck = Value
End Property

Public Property Get IsEnemyInCheck() As Boolean
    IsEnemyInCheck = m_IsEnemyInCheck
End Property

Public Property Let IsEnemyInCheck(ByVal Value As Boolean)
    m_IsEnemyInCheck = Value
End Property

Public Property Get EnemyStatus() As Integer
    EnemyStatus = m_EnemyStatus
End Property

Public Property Let EnemyStatus(ByVal Value As Integer)
    m_EnemyStatus = Value
End Property

Public Property Get Counter50MDraw() As Byte
    Counter50MDraw = m_counter50MDraw
End Property

Public Property Let Counter50MDraw(ByVal counterValue As Byte)
    m_counter50MDraw = counterValue
End Property

Public Property Get Is50MDraw() As Boolean
    Is50MDraw = m_counter50MDraw >= 100
End Property

Private Sub RookCastle(ByVal ordinalRookFrom As Integer, ByVal fileTo As Integer, _
                       ByVal playerThis As Player)
Dim boardThis As Board, pieceRook As Piece, sqrRookFrom As Square, sqrRookTo As Square
Dim ordinalRookTo As Integer
    
    Set boardThis = playerThis.BoardChess
    Set sqrRookFrom = boardThis.GetSquare(ordinalRookFrom)
    Set pieceRook = sqrRookFrom.PieceOnSquare
    
    ordinalRookTo = (ordinalRookFrom And &HF0) + fileTo
    Set sqrRookTo = boardThis.GetSquare(ordinalRookTo)
    sqrRookTo.SetPieceSquare pieceRook
    pieceRook.SetSquare sqrRookTo
    sqrRookFrom.SetPieceSquare Nothing
    pieceRook.LastMoveTurnNo = m_turnNo
    pieceRook.NoOfMovesIncr
    playerThis.HasCastled = True
End Sub

Private Sub RookUnCastle(ByVal ordinalRookTo As Integer, ByVal fileFrom As Integer, _
                       ByVal playerThis As Player)
Dim boardThis As Board, pieceRook As Piece, sqrRookFrom As Square, sqrRookTo As Square
Dim ordinalRookFrom As Integer
                       
    Set boardThis = playerThis.BoardChess
    Set sqrRookTo = boardThis.GetSquare(ordinalRookTo)
    Set pieceRook = sqrRookTo.PieceOnSquare
    
    ordinalRookFrom = (ordinalRookTo And &HF0) + fileFrom
    Set sqrRookFrom = boardThis.GetSquare(ordinalRookFrom)
    pieceRook.SetSquare sqrRookFrom
    sqrRookFrom.SetPieceSquare pieceRook
    sqrRookTo.SetPieceSquare Nothing
    pieceRook.LastMoveTurnNo = 0
    pieceRook.NoOfMovesDecr
    playerThis.HasCastled = False
End Sub

Public Sub DoMove()
Dim isCounterDraw50Moves As Boolean
Dim playerThis As Player, boardThis As Board, typeOfPiece As Integer

    Set playerThis = m_pieceMoved.Player
    Set boardThis = playerThis.BoardChess
    typeOfPiece = m_pieceMoved.TypePiece
    isCounterDraw50Moves = typeOfPiece <> typePawn
    If Not m_pieceCaptured Is Nothing Then
        isCounterDraw50Moves = False
        m_pieceCaptured.Capture
    End If
    m_pieceMoved.Square.SetPieceSquare Nothing
    m_squareTo.SetPieceSquare m_pieceMoved
    m_pieceMoved.SetSquare m_squareTo
    m_LastMoveTurnNo = m_pieceMoved.LastMoveTurnNo
    m_turnNo = boardThis.TurnNo
    m_pieceMoved.LastMoveTurnNo = boardThis.TurnNoIncr()
    m_pieceMoved.NoOfMovesIncr
    
    Select Case typeOfPiece
    Case typePawn
        Select Case m_typeMove
        Case movePromotionQueen To movePromotionKnight
            m_pieceMoved.Promote typeQueen + m_typeMove - movePromotionQueen
        End Select
        
    Case typeKing
        Select Case m_typeMove
        Case moveCastleKingSide
            RookCastle IIf(playerThis.isWhite, h1, h8), fileF, playerThis
            
        Case moveCastleQueenSide
            RookCastle IIf(playerThis.isWhite, a1, a8), fileD, playerThis
        End Select
    End Select
    m_IsInCheck = playerThis.IsInCheck
    m_IsEnemyInCheck = playerThis.OtherPlayer.IsInCheck
    
    If isCounterDraw50Moves Then
        m_counter50MDraw = boardThis.MoveHistoryLast.Counter50MDraw + 1
    End If
    boardThis.MoveHistory.Add Me
    
End Sub

Public Sub UndoMove()
Dim pieceTo As Piece, sqrPawn As Square
Dim playerThis As Player, boardThis As Board, moveLast As Move, typeOfPiece As Integer

    Set playerThis = m_pieceMoved.Player
    Set boardThis = playerThis.BoardChess
    Set pieceTo = m_squareTo.PieceOnSquare
    If pieceTo Is Nothing Then ErrWarn 3600
    m_pieceMoved.SetSquare m_squareFrom
    m_squareFrom.SetPieceSquare m_pieceMoved
    
    typeOfPiece = m_pieceMoved.TypePiece
    If (typeOfPiece = typePawn) And _
        (m_squareFrom.Ordinal = m_pieceMoved.SquareInitial.Ordinal) Then
        m_pieceMoved.NoOfMoves = 0
    Else
        m_pieceMoved.NoOfMovesDecr
    End If
    If m_pieceCaptured Is Nothing Then
        m_squareTo.SetPieceSquare Nothing
    Else
        m_squareTo.SetPieceSquare m_pieceCaptured
        If m_pieceCaptured.TypePiece = typePawn Then
            m_pieceCaptured.UncapturePawn
            If m_typeMove = moveEnPassant Then
                m_squareTo.SetPieceSquare Nothing
                Set sqrPawn = boardThis.GetSquare(m_squareTo.Ordinal - _
                                playerThis.PawnForwardOffset)
                sqrPawn.SetPieceSquare m_pieceCaptured
            End If
        Else
            m_pieceCaptured.UncaptureNonPawn
        End If
    End If
    
    Select Case typeOfPiece
    Case typeQueen To typeKnight
        Select Case m_typeMove
        Case movePromotionQueen To movePromotionKnight
            m_pieceMoved.Demote
        End Select
        
    Case typeKing
        Select Case m_typeMove
        Case moveCastleKingSide
            RookUnCastle IIf(playerThis.isWhite, f1, f8), fileH, playerThis
            
        Case moveCastleQueenSide
            RookUnCastle IIf(playerThis.isWhite, d1, d8), fileA, playerThis
        End Select
    End Select
    boardThis.TurnNoDecr
    boardThis.MoveHistoryRemoveLast
    
End Sub

Public Property Let Description(ByVal strValue As String)
    m_notationPgnSan = strValue
End Property

Public Property Get Description() As String
    Description = m_notationPgnSan
End Property

Public Property Get Key() As String
    Key = m_key
End Property

Public Property Get DescrFull() As String
Dim strMove As String, indSep As Byte, lenMove As Byte, isSep As Boolean
Dim strSqrFrom As String

    strMove = m_notationPgnSan
    lenMove = Len(strMove)
    If lenMove > 0 Then
        If m_typeMove <> moveCastleQueenSide And m_typeMove <> moveCastleKingSide Then
            indSep = InStr(strMove, "x")
            isSep = indSep > 0
            If isSep Then
                If m_pieceCaptured.TypePiece <> typePawn Then
                    strMove = Left(strMove, indSep - 1) + "x" + m_pieceCaptured.Name + Mid(strMove, indSep + 1)
                End If
            Else
                indSep = InStr(strMove, "=")
                isSep = indSep > 0
            End If
            If indSep = 0 Then
                indSep = lenMove - 1
                If InStr("+#", Right(strMove, 1)) > 0 Then
                    indSep = indSep - 1
                End If
            End If
            strSqrFrom = m_squareFrom.Name
            If Not isSep Then
                strSqrFrom = strSqrFrom + "-"
            End If
            strMove = IIf(m_pieceMoved.TypePiece = typePawn, "", Left(strMove, 1)) + _
                          strSqrFrom + Mid(strMove, indSep)
        End If
    End If
    DescrFull = strMove
End Property

Private Sub PgnPieceName(ByVal isSolvePgnAmbiguity)
Dim pieceTwin As Piece, listTwin As Collection, indTwin As Integer

    If m_pieceMoved.TypePiece = typePawn Then
        If Not m_pieceCaptured Is Nothing Then
            m_notationPgnSan = m_notationPgnSan + m_squareFrom.Filename ' File of the pawn only if capture
        End If
    ElseIf m_pieceMoved.HasBeenPromoted And _
        (m_pieceMoved.TurnNoPromotion >= m_pieceMoved.Player.BoardChess.TurnNo) Then
        If Not m_pieceCaptured Is Nothing Then
            m_notationPgnSan = m_notationPgnSan + m_squareFrom.Filename ' File of the pawn only if capture
        End If
    Else
        m_notationPgnSan = m_notationPgnSan + m_pieceMoved.Name
        If isSolvePgnAmbiguity Then
            If m_pieceMoved.twinAligned(listTwin) Then
                For indTwin = 1 To listTwin.Count
                    Set pieceTwin = listTwin(indTwin)
                    If pieceTwin.isAttacking(m_squareTo.Ordinal) Then
                        If pieceTwin.Square.File <> m_squareFrom.File Then
                            m_notationPgnSan = m_notationPgnSan + m_squareFrom.Filename
                        ElseIf pieceTwin.Square.Rank <> m_squareFrom.Rank Then
                            m_notationPgnSan = m_notationPgnSan + m_squareFrom.RankName
                        End If
                        Exit For
                    End If
                Next
            End If
        End If
    End If
End Sub

Public Function PgnSanFormat(ByVal isSolvePgnAmbiguity As Boolean) As String

    If isSolvePgnAmbiguity Then
        m_notationPgnSan = ""
    End If
    If Len(m_notationPgnSan) = 0 Then
        Select Case m_typeMove
        Case moveCastleQueenSide
            m_notationPgnSan = "O-O-O"
            
        Case moveCastleKingSide
            m_notationPgnSan = "O-O"
            
        Case Else
            PgnPieceName isSolvePgnAmbiguity
            If Not m_pieceCaptured Is Nothing Then
                m_notationPgnSan = m_notationPgnSan + "x"
            End If
            m_notationPgnSan = m_notationPgnSan + m_squareTo.Name
        End Select
        
        Select Case m_typeMove
        Case movePromotionQueen
            m_notationPgnSan = m_notationPgnSan + IIf(isFrench, "=D", "=Q")
            
        Case movePromotionRook
            m_notationPgnSan = m_notationPgnSan + IIf(isFrench, "=T", "=R")
            
        Case movePromotionBishop
            m_notationPgnSan = m_notationPgnSan + IIf(isFrench, "=F", "=B")
            
        Case movePromotionKnight
            m_notationPgnSan = m_notationPgnSan + IIf(isFrench, "=C", "=N")
            
        End Select
        Select Case m_EnemyStatus
        Case statusInCheck
            m_notationPgnSan = m_notationPgnSan + "+"
            
        Case statusInCheckMate
            m_notationPgnSan = m_notationPgnSan + "#"
        End Select
    End If
    PgnSanFormat = m_notationPgnSan
End Function

Public Function Clone(boardTarget As Board) As Move
Dim sqrFrom As Square, sqrTo As Square
Dim pieceToMove As Piece, pieceToCapture As Piece
Dim moveClone As Move

    Set sqrFrom = boardTarget.GetSquare(m_squareFrom.Ordinal)
    Set pieceToMove = boardTarget.GetPiece(m_squareFrom.Ordinal)
    
    Set sqrTo = boardTarget.GetSquare(m_squareTo.Ordinal)
    If m_pieceCaptured Is Nothing Then
        Set pieceToCapture = Nothing
    Else
        Set pieceToCapture = boardTarget.GetPiece(m_pieceCaptured.Square.Ordinal)
    End If
    Set moveClone = New Move
    moveClone.BuildMove m_typeMove, pieceToMove, sqrFrom, sqrTo, pieceToCapture

    Set Clone = moveClone
    
End Function






